import java.io.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

class PseudoTerm extends JFrame {

    PipedOutputStream pp = new PipedOutputStream();
    PrintStream ps = new PrintStream(pp);
    BufferedReader br;

    JTextField tf = new JTextField();
    JTextArea ta = new JTextArea();
    JScrollPane sp = new JScrollPane(ta);

    boolean echo = true;


    public PseudoTerm(String title) {
        super(title);

        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent w) { System.exit(0); }
        });  

        getContentPane().setLayout(new BorderLayout());
        getContentPane().add("Center", sp);
        getContentPane().add("South",  tf);
        ta.setEditable(false);
        tf.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                String s = tf.getText();
	        if (echo) ta.append(s+"\n");
                ta.setCaretPosition (ta.getText().length() - 1) ;
	        tf.setText("");
                ps.println(s);
	        ps.flush();
            }
        });

        try {
            br = new BufferedReader(new InputStreamReader(new PipedInputStream(pp)));
        } catch(IOException e) { println("Cannot create BufferedReader\n"+e); }

        pack();
        setVisible(true);
    }



    public Dimension  getPreferredSize() {
        return new Dimension(400,400);
    }


    void println(String s) {
        ta.setForeground(Color.blue);
        ta.append(s+"\n");
        ta.setForeground(Color.black);
        ta.setCaretPosition (ta.getText().length() - 1) ;
    }


    String readln() {
        try{
            return br.readLine();
        } catch(IOException e) { 
            println("Cannot read from BufferedReader\n"+e); 
            return null; 
        }
    }


    int readInt() {
        try{
            return Integer.parseInt(readln());
        } catch(NumberFormatException e) { 
            println("Not an integer, try again"); 
            return readInt(); 
        }
    }

}
